'T13_4094_3D.bas
'Ansteuerung zweier Schieberegister 4094
'mit dem ATtiny13
'erste Version :24.11.2008, auf zwei 4094
'erweiterte Version: 20.01.2009

$regfile = "attiny13.dat"
$crystal = 1200000
Config Portb.0 = Output
Config Portb.3 = Output
Config Portb.4 = Output

Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
Open "comb.2:9600,8,n,1,inverted" For Input As #2

Dim N As Byte
Dim Daten As Byte
Dim Daten1 As Byte
D Alias Portb.0
Clk Alias Portb.3
Strobe1 Alias Portb.4
Strobe2 Alias Portb.1

Start:
Clk = 1
Strobe1 = 1
Strobe2 = 1
D = 0                                                       ' Bei beiden 4094
Daten = 0                                                   ' alle Ausgangsbits lschen
Gosub Weiter1
Daten = 0
Gosub Weiter2


Do
Get #2 , Daten
Select Case Daten
Case 1 : Gosub 4094_1
Case 2 : Gosub 4094_2
Case Is >= 2 : Gosub 4094_2
End Select
Loop

4094_1:
Get #2 , Daten
Weiter1:
Daten1 = Daten
D = 0
Strobe1 = 0
Clk = 0
Gosub Schieben
Strobe1 = 1
Strobe1 = 0
Return

4094_2:
Get #2 , Daten
Weiter2:
Daten1 = Daten
D = 0
Strobe2 = 0
Clk = 0
Gosub Schieben
Strobe2 = 1
Strobe2 = 0
Return

Schieben:
For N = 0 To 7
D = 0
Daten1 = Daten And 128                                      'Bit 7 testen
If Daten1 = 128 Then
D = 1
Else
D = 0
End If
Clk = 1
Clk = 0
Shift Daten , Left                                          'nacheinander alle Bits
                                                             'an Position von Bit 7 schieben
Next N
Return

End