'T13_HC595_1.bas
'Ansteuerung eines Schieberegisters 74HC595
'mit dem ATtiny13
'erste Version vom 24.11.2008 fr das IC 4094, angepasst am 18.01.2009
'fr den Baustein 74HC595


$regfile = "attiny13.dat"
$crystal = 1200000
Config Portb.0 = Output
Config Portb.3 = Output
Config Portb.4 = Output

Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
Open "comb.2:9600,8,n,1,inverted" For Input As #2

Dim N As Byte
Dim Daten As Byte
Dim Daten1 As Byte
Ser_in Alias Portb.0                                        'Serial Data Input
Sck Alias Portb.3                                           'Shift Register Clock Input
Rck Alias Portb.4                                           'Storage Register Clock Input

Start:
Ser_in = 0
Sck = 0
Rck = 0

Do
Get #2 , Daten
Daten1 = Daten
Put #1 , Daten
Gosub Schieben
Loop

Schieben:

Ser_in = 0
Rck = 0
Sck = 0

For N = 0 To 7
Daten1 = Daten And 1                                        'Zuerst wird Bit 7 bertragen
If Daten1 = 1 Then                                          'wenn Ser_in = 1
Ser_in = 1
Sck = 0
Sck = 1
Else                                                        'wenn Ser_in = 0
Ser_in = 0
Sck = 0
Sck = 1
End If

Shift Daten , Right
Next N

Ser_in = 1
Rck = 1
Return

End