'T13_HC595_D4.bas
'Ansteuerung zweier Schieberegister 74HC595
'mit dem ATtiny13
'erste Version vom 24.11.2008 fr ein IC 4094, erweitert und
'angepasst am 18.01.2009 fr zwei ICs 74HC595


$regfile = "attiny13.dat"
$crystal = 1200000
Config Portb.0 = Output
Config Portb.3 = Output
Config Portb.4 = Output
Config Portb.1 = Output

Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
Open "comb.2:9600,8,n,1,inverted" For Input As #2

Dim N As Byte
Dim Daten As Byte
Dim Daten1 As Byte

Ser_in Alias Portb.0                                        'Serial Data Input
Sck Alias Portb.3                                           'Shift Register Clock Input
Rck2 Alias Portb.1
Rck1 Alias Portb.4                                          'Storage Register Clock Input

Start:
Portb.1 = 0                                                 ' Ausgabe an 74HC595_1
Ser_in = 0
Sck = 0
Rck1 = 0
Rck2 = 0                                                    ' eventuell noch gesetzte
Daten = 0                                                   ' Ausgangs-Bits lschen
Gosub Ic1_pr
Daten = 0
Gosub Ic2_pr

Do
Sck = 0                                                     'Storage Register Clock Input1
Rck1 = 0                                                    'Storage Register Clock Input2
Rck2 = 0
Get #2 , Daten
Select Case Daten
Case 1 : Gosub Ic1_pr                                       ' Auswahl des 74HC595-Bausteins,
Case 2 : Gosub Ic2_pr                                       ' der angesteuert wird
Case Is >= 3 : Gosub Ic2_pr
End Select
Loop

Ic2_pr:
Rck2 = 0
Get #2 , Daten
Weiter2:
Daten1 = Daten
Gosub Schieben                                              ' in Unterprogramm verzweigen
Rck2 = 1                                                    ' und Daten bernehmen
Rck2 = 0
Return

Ic1_pr:
Rck1 = 0
Get #2 , Daten
Weiter1:
Daten1 = Daten
Gosub Schieben
Rck1 = 1
Rck1 = 0
Return


Schieben:
Ser_in = 0
Sck = 0

For N = 0 To 7
Daten1 = Daten And 128                                      ' Zuerst wird Bit 7 bertragen
If Daten1 = 128 Then                                        'wenn Ser_in =1
Ser_in = 1
Sck = 0
Sck = 1
Else                                                        'wenn Ser_in 0
Ser_in = 0
Sck = 0
Sck = 1
End If

Shift Daten , Left
Next N

Ser_in = 1
Return

End